#!/usr/bin/env bash

# https://wiki.ubuntuusers.de/geoiplookup/
# https://github.com/colebrooke/slack-ssh-login-notification/blob/master/login-slack-notify.sh
# https://medium.com/star-systems-labs/monitoring-ssh-login-via-slack-3012a16fd02b
if [ "$PAM_TYPE" != "close_session" ]; then

  ! {
    channel="{{ ssh_slack_channel }}"

    HOST=`hostname -s`
    IPS=`hostname -I`
    DATE=`date`

    message="SSH login: ${PAM_USER} connected to ${HOST} (${IPS})"

    curl >/dev/null \
        -s \
        -X POST \
        -d@- \
        {{ ssh_slack_webhook_url }} << EOF
        payload={
            "channel": "${channel}",
            "mrkdwn": true,
            "username": "T-800",
            "attachments": [{
              "mrkdwn_in": ["text", "fallback"],
              "fallback": ${message},
              "text": ${message},
              "fields": [{
                  "title": "User",
                  "value": "${PAM_USER}",
                  "short": true
              }, {
                  "title": "IP Address",
                  "value": "${PAM_RHOST}",
                  "short": true
              },
              {
                  "title": "Date",
                  "value": "`${DATE}`",
                  "short": true
              },
              {
                  "title": "Hostname",
                  "value": "${HOST}",
                  "short": true
              }],
              "color": "#F35A00"
            }],
            "icon_emoji": ":computer:"
        }
    EOF

  }
fi
exit 0
